diff -crN nakedmudv1.5/src/olc2/olc.c nakedmudv2.0/src/olc2/olc.c
*** nakedmudv1.5/src/olc2/olc.c	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/olc2/olc.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,291 ----
+ //*****************************************************************************
+ //
+ // olc.c
+ //
+ // My first go at OLC was during the pre-module time, and it really wasn't all
+ // that well put together in the first place. This is the second go at it...
+ // this time, OLC is more like some general functions that make it easy to do
+ // online editing, rather than a full system. It will be amenable to adding
+ // new extentions to the general OLC framework from other modules, and it will
+ // essentially just be a bunch spiffier.
+ //
+ //*****************************************************************************
+ 
+ #include "../mud.h"
+ #include "../utils.h"
+ #include "../socket.h"
+ #include "../world.h"
+ #include "../character.h"  // for POS_XXX <-- we should change the place of this
+ #include "../auxiliary.h"
+ #include "olc.h"
+ 
+ 
+ 
+ //*****************************************************************************
+ //
+ // local data structures, defines, and functions
+ //
+ //*****************************************************************************
+ typedef struct olc_data {
+   void    (* menu)(SOCKET_DATA *, void *);
+   int  (* chooser)(SOCKET_DATA *, void *, char);
+   bool  (* parser)(SOCKET_DATA *, void *, int, const char *);
+   void *(* copier)(void *);
+   void  (* copyto)(void *, void *);
+   void (* deleter)(void *);
+   void   (* saver)(void *); 
+   void *data;
+   void *working_copy;
+   int  cmd;
+ } OLC_DATA;
+ 
+ OLC_DATA *newOLC(void    (* menu)(SOCKET_DATA *, void *),
+ 		 int  (* chooser)(SOCKET_DATA *, void *, char),
+ 		 bool  (* parser)(SOCKET_DATA *, void *, int, const char *),
+ 		 void *(* copier)(void *),
+ 		 void  (* copyto)(void *, void *),
+ 		 void (* deleter)(void *),
+ 		 void   (* saver)(void *),
+ 		 void *data) {
+   OLC_DATA *olc     = malloc(sizeof(OLC_DATA));
+   olc->menu         = menu;
+   olc->chooser      = chooser;
+   olc->parser       = parser;
+   olc->copier       = copier;
+   olc->copyto       = copyto;
+   olc->deleter      = deleter;
+   olc->saver        = saver;
+   olc->data         = data;
+   olc->working_copy = (copier ? copier(data) : data);
+   olc->cmd          = MENU_NOCHOICE;
+   return olc;
+ }
+ 
+ void deleteOLC(OLC_DATA *olc) {
+   if(olc->deleter) olc->deleter(olc->working_copy);
+   free(olc);
+ }
+ 
+ 
+ 
+ //*****************************************************************************
+ //
+ // auxiliary data we put on the socket
+ //
+ //*****************************************************************************
+ typedef struct olc_aux_data {
+   LIST *olc_stack; // the list of OLCs we have opened
+ } OLC_AUX_DATA;
+ 
+ OLC_AUX_DATA *
+ newOLCAuxData() {
+   OLC_AUX_DATA *data = malloc(sizeof(OLC_AUX_DATA));
+   data->olc_stack = newList();
+   return data;
+ }
+ 
+ void
+ deleteOLCAuxData(OLC_AUX_DATA *data) {
+   if(data->olc_stack) deleteListWith(data->olc_stack, deleteOLC);
+   free(data);
+ }
+ 
+ 
+ 
+ //*****************************************************************************
+ //
+ // Implementation of the OLC framework
+ //
+ //*****************************************************************************
+ 
+ //
+ // display the current menu to the socket, as well as the generic prompt
+ //
+ void olc_menu(SOCKET_DATA *sock) {
+   // send the current menu
+   OLC_AUX_DATA *aux_olc = socketGetAuxiliaryData(sock, "olc_aux_data");
+   OLC_DATA         *olc = listGet(aux_olc->olc_stack, 0);
+   // don't display then menu if we've made a menu choice
+   if(olc->cmd == MENU_NOCHOICE) {
+     text_to_buffer(sock, CLEAR_SCREEN);
+     olc->menu(sock, olc->working_copy);
+     text_to_buffer(sock, "\r\nEnter choice, or Q to quit: ");
+   }
+ }
+ 
+ 
+ //
+ // handle the cleanup process for exiting OLC; pop the top handler off of
+ // the OLC stack and delete it. Save changes if neccessary. Exit the OLC handler
+ // if we have no more OLC work to do. Return the new and improved version of
+ // whatever it was we were editing.
+ //
+ void *olc_exit(SOCKET_DATA *sock, bool save) {
+   // pull up the OLC data to manipulate
+   OLC_AUX_DATA *aux_olc = socketGetAuxiliaryData(sock, "olc_aux_data");
+   OLC_DATA         *olc = listGet(aux_olc->olc_stack, 0);
+   void            *data = olc->data;
+ 
+   // pop our OLC off of the OLC stack
+   listPop(aux_olc->olc_stack);
+ 
+   // if we need to do any saving, do it now
+   if(save) {
+     // first, save the changes on the item
+     if(olc->working_copy != olc->data && olc->copyto)
+       olc->copyto(olc->working_copy, olc->data);
+     // now, make sure the changes go to disk
+     if(olc->saver)
+       olc->saver(olc->data);
+   }
+ 
+   // delete our OLC data (this also deletes our working copy 
+   // if it's not the same as our main copy)
+   deleteOLC(olc);
+ 
+   // if our OLC stack is empty, pop the OLC input handler
+   if(listSize(aux_olc->olc_stack) == 0)
+     socketPopInputHandler(sock);
+   return data;
+ }
+ 
+ 
+ //
+ // Handle input while in OLC
+ //
+ void olc_handler(SOCKET_DATA *sock, char *arg) {
+   // pull up the OLC data. Are we entering a new command, or are
+   // we entering in an argument from a menu choice?
+   OLC_AUX_DATA *aux_olc = socketGetAuxiliaryData(sock, "olc_aux_data");
+   OLC_DATA         *olc = listGet(aux_olc->olc_stack, 0);
+ 
+   // we're giving an argument for a menu choice we've already selected
+   if(olc->cmd > MENU_NOCHOICE) {
+     // the change went alright. Re-display the menu
+     if(olc->parser(sock, olc->working_copy, olc->cmd, arg)) {
+       olc->cmd = MENU_NOCHOICE;
+       olc_menu(sock);
+     }
+     else
+       text_to_buffer(sock, "Invalid choice!\r\nTry again: ");
+   }
+ 
+   // we're being prompted if we want to save our changes or not before quitting
+   else if(olc->cmd == MENU_CHOICE_CONFIRM_SAVE) {
+     switch(toupper(*arg)) {
+     case 'Y':
+     case 'N':
+       olc_exit(sock, (toupper(*arg) == 'Y' ? TRUE : FALSE));
+       break;
+     default:
+       text_to_buffer(sock, "Invalid choice!\r\nTry again: ");
+       break;
+     }
+   }
+ 
+   // we're entering a new choice from our current menu
+   else {
+     switch(*arg) {
+       // we're quitting
+     case 'q':
+     case 'Q':
+       // if our working copy is different from our actual data, prompt to
+       // see if we want to save our changes or not
+       if(olc->working_copy != olc->data) {
+ 	text_to_buffer(sock, "Save changes (Y/N): ");
+ 	olc->cmd = MENU_CHOICE_CONFIRM_SAVE;
+       }
+       else {
+ 	olc_exit(sock, TRUE);
+       }
+       break;
+ 
+     default: {
+       int cmd = olc->chooser(sock, olc->working_copy, *arg);
+       // the menu choice we entered wasn't a valid one. redisplay the menu
+       if(cmd == MENU_CHOICE_INVALID)
+ 	olc_menu(sock);
+       // the menu choice was acceptable. Note this in our data
+       else if(cmd > MENU_NOCHOICE)
+ 	olc->cmd = cmd;
+       break;
+     }
+     }
+   }
+ }
+ 
+ 
+ 
+ //*****************************************************************************
+ //
+ // implementation of olc.h
+ //
+ //*****************************************************************************
+ 
+ void init_olc2() {
+   // install our auxiliary data on the socket so 
+   // we can keep track of our olc data
+   auxiliariesInstall("olc_aux_data",
+ 		     newAuxiliaryFuncs(AUXILIARY_TYPE_SOCKET,
+ 				       newOLCAuxData, deleteOLCAuxData,
+ 				       NULL, NULL, NULL, NULL));
+ 
+   // initialize all of our basic OLC commands
+   extern COMMAND(cmd_redit);
+   extern COMMAND(cmd_zedit);
+   extern COMMAND(cmd_dedit);
+   extern COMMAND(cmd_medit);
+   extern COMMAND(cmd_oedit);
+   add_cmd("zedit", NULL, cmd_zedit, 0, POS_UNCONCIOUS, POS_FLYING,
+ 	  LEVEL_BUILDER, FALSE, TRUE);
+   add_cmd("redit", NULL, cmd_redit, 0, POS_UNCONCIOUS, POS_FLYING,
+ 	  LEVEL_BUILDER, FALSE, TRUE);
+   add_cmd("dedit", NULL, cmd_dedit, 0, POS_UNCONCIOUS, POS_FLYING,
+ 	  LEVEL_BUILDER, FALSE, TRUE);
+   add_cmd("medit", NULL, cmd_medit, 0, POS_UNCONCIOUS, POS_FLYING,
+ 	  LEVEL_BUILDER, FALSE, TRUE);
+   add_cmd("oedit", NULL, cmd_oedit, 0, POS_UNCONCIOUS, POS_FLYING,
+ 	  LEVEL_BUILDER, FALSE, TRUE);
+ }
+ 
+ void do_olc(SOCKET_DATA *sock,
+ 	    void *menu,
+ 	    void *chooser,
+ 	    void *parser,
+ 	    void *copier,
+ 	    void *copyto,
+ 	    void *deleter,
+ 	    void *saver,
+ 	    void *data) {
+   // first, we create a new OLC data structure, and then push it onto the stack
+   OLC_DATA *olc = newOLC(menu, chooser, parser, copier, copyto, deleter,
+ 			 saver, data);
+   OLC_AUX_DATA *aux_olc = socketGetAuxiliaryData(sock, "olc_aux_data");
+   listPush(aux_olc->olc_stack, olc);
+ 
+   // if this is the only olc data on the stack, then enter the OLC handler
+   if(listSize(aux_olc->olc_stack) == 1)
+     socketPushInputHandler(sock, olc_handler, olc_menu);
+ }
+ 
+ void save_world(void *olc_data) {
+   worldSave(gameworld, WORLD_PATH);
+ }
+ 
+ void olc_display_table(SOCKET_DATA *sock, const char *getName(int val),
+ 		       int num_vals, int num_cols) {
+   int i, print_room;
+   static char fmt[SMALL_BUFFER];
+ 
+   print_room = (80 - 10*num_cols)/num_cols;
+   sprintf(fmt, "  {c%%2d{y) {g%%-%ds%%s", print_room);
+ 
+   for(i = 0; i < num_vals; i++)
+     send_to_socket(sock, fmt, i, getName(i), 
+ 		   (i % num_cols == (num_cols - 1) ? "\r\n" : "   "));
+ 
+   if(i % num_cols != 0)
+     send_to_socket(sock, "\r\n");
+ 
+   text_to_buffer(sock, "Pick an option: ");
+ }
diff -crN nakedmudv1.5/src/olc2/olc.d nakedmudv2.0/src/olc2/olc.d
*** nakedmudv1.5/src/olc2/olc.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/olc2/olc.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,3 ----
+ olc2/olc.d olc2/olc.o: olc2/olc.c mud.h wrapsock.h property_table.h list.h map.h \
+   hashtable.h set.h buffer.h bitvector.h utils.h socket.h world.h \
+   character.h auxiliary.h olc2/olc.h
diff -crN nakedmudv1.5/src/olc2/olc.h nakedmudv2.0/src/olc2/olc.h
*** nakedmudv1.5/src/olc2/olc.h	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/olc2/olc.h	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,111 ----
+ #ifndef OLC2_H
+ #define OLC2_H
+ //*****************************************************************************
+ //
+ // olc.h
+ //
+ // My first go at OLC was during the pre-module time, and it really wasn't all
+ // that well put together in the first place. This is the second go at it...
+ // this time, OLC is more like some general functions that make it easy to do
+ // online editing, rather than a full system. It will be amenable to adding
+ // new extentions to the general OLC framework from other modules, and it will
+ // essentially just be a bunch spiffier.
+ //
+ //*****************************************************************************
+ 
+ //
+ // prepare the OLC framework for use
+ void init_olc2();
+ 
+ //
+ // Set up a new OLC. OLCs can be stacked on top of eachother (e.g. room edit
+ // could call extra description edit. After the extra description edit is
+ // exited, room edit will continue). If this is the only OLC in use, OLC mode
+ // will automatically be entered. Below are descriptions of the paramaters the
+ // following function takes, and the form they should be:
+ //
+ // menu: This is a function that displays the current OLC menu to the socket.
+ //       void menu(SOCKET_DATA *sock, datatype *to_display)
+ //
+ // chooser: This is a function that takes in the menu option that the socket 
+ //       wishes to select. The values q and Q are reserved by the OLC handler
+ //       for quitting. The chooser is responsible for prompting the socket for 
+ //       appropriate arguments after a menu option has been selected. There are
+ //       three types of values that can be returned:
+ //          -1     invalid option
+ //           0     Valid choice, but we do not need to enter the parser. This
+ //                 would be returned, for instance, if a new do_olc was called,
+ //                 or if a toggle on/off menu option was selected.
+ //         >= 1    a numeric value representing the field we are editing. This
+ //                 will be passed to the modifier() function to perform changes
+ //                 after an argument is passed in.
+ //       the chooser function is of the form:
+ //       int chooser(SOCKET_DATA *sock, datatype *to_edit, char option)
+ //
+ // parser: This function is used to parse an argument, given a choice from the
+ //       menu. The choice is provided by the chooser() function, and an argument
+ //       is supplied afterwards. TRUE should be returned if the argument was
+ //       valid and the command was a success, and FALSE if it was not. 
+ //       The parser takes the form:
+ //       bool parser(SOCKET_DATA *sock, datatype *to_edit, int choice, 
+ //                   const char *arg)
+ //
+ // copier: This is a function that returns a deep copy of the data we are
+ //       editing. The data is not worked on, directly. Rather, a copy of it
+ //       is made and edited. If the changes are accepted at the end of OLC, they
+ //       are copied back over to the thing we were editing. This parameter can
+ //       be NULL if the data is to be worked on directly. The function is of
+ //       the form: void copier(datatype *thing_to_copy)
+ //
+ // copyto: This copies the data of one thing over to another datastructure of
+ //       the same type. This parameter can be NULL if the data is to be worked
+ //       on directly. This function takes the form:
+ //       void copyto(datatype *thing_to_copy_from, datatype *thing_to_copy_to)
+ //
+ // saver: After OLC is exited, we'll typically need to save the changes to disk.
+ //       this is the function that should be called to save all of the changes
+ //       that have been made. Saver can be null if changes are not to be saved
+ //       to disk after they have been made. This function takes the form:
+ //       void saver(datatype *working_copy)
+ //
+ // deleter: this is a function that will delete the working copy of our data.
+ //       This parameter can be NULL if the data is to be worked on directly.
+ //       This function takes the form:
+ //       void delete(datatype *working_copy)
+ #define MENU_CHOICE_CONFIRM_SAVE   (-2) // this define for internal use only!
+ #define MENU_CHOICE_INVALID        (-1)
+ #define MENU_NOCHOICE               (0)
+ 
+ void do_olc(SOCKET_DATA *sock,
+ 	    void *menu,
+ 	    void *chooser,
+ 	    void *parser,
+ 	    void *copier,
+ 	    void *copyto,
+ 	    void *deleter,
+ 	    void *saver,
+ 	    void *data);
+ 
+ 
+ 
+ //*****************************************************************************
+ // To keep a general "look and feel" to OLCs, a couple functions have been
+ // provided to display some features of an OLC in a standard manner.
+ //*****************************************************************************
+ 
+ //
+ // Okay, so I'm lazy. I don't want to write a saver() function for each type of
+ // thing that can be edited in OLC. Here is a function that will save any
+ // change, whether it's to a mob proto, an obj proto, or a room proto. It will
+ // be slow for a large mud, since it basically saves the -entire- world to disk,
+ // but you can work on changing that if your world gets big enough ;)
+ void save_world(void *olc_data);
+ 
+ 
+ //
+ // Display a bunch of options in a tabular form. The table will have num_vals
+ // elements, and num_cols of those elements will be displayed per row.
+ void olc_display_table(SOCKET_DATA *sock, const char *getName(int val),
+ 		       int num_vals, int num_cols);
+ 
+ #endif // OLC2_H
diff -crN nakedmudv1.5/src/olc2/olc_submenus.h nakedmudv2.0/src/olc2/olc_submenus.h
*** nakedmudv1.5/src/olc2/olc_submenus.h	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/olc2/olc_submenus.h	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,21 ----
+ #ifndef OLC_SUBMENUS_H
+ #define OLC_SUBMENUS_H
+ //*****************************************************************************
+ //
+ // olc_submenus.h
+ //
+ // There's some OLC editors that will only ever be called from within another
+ // olc editor (e.g. the extra description editor inside the room editor). They
+ // may need to be called by multiple editors (e.g. extra descs in rooms, and
+ // for objects), so we have to give them access to all of the olc-related
+ // functions. That's what this header provides.
+ //
+ //*****************************************************************************
+ 
+ // extra description sets
+ void edesc_set_menu   (SOCKET_DATA *sock, EDESC_SET *set);
+ bool edesc_set_parser (SOCKET_DATA *sock, EDESC_SET *set, int choice,
+ 		       const char *arg);
+ int  edesc_set_chooser(SOCKET_DATA *sock, char option, EDESC_SET *set);
+ 
+ #endif // OLC_SUBMENUS_H
